unit test;

{$mode objfpc}{$H+}

interface

uses  fpsutils, fpsExprParser,
  Classes, SysUtils, FileUtil,
  fpSpreadSheet, fpspreadsheetgrid, fpspreadsheetctrls,  fpsallformats,
  fpsTypes, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls, ComCtrls,
   Menus, Buttons;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    bt1Src: TButton;
    bt9Test2: TButton;
    Button2: TButton;
    Button7: TButton;
    bt18Test1: TButton;
    cb1AutoCalc: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    SaveDialog1: TSaveDialog;
    sCellEdit2: TsCellEdit;
    sCellIndicator1: TsCellIndicator;
    wbSource1: TsWorkbookSource;
    sWorkbookTabControl1: TsWorkbookTabControl;
    wsGrid1: TsWorksheetGrid;
    procedure bt1SrcClick(Sender: TObject);
    procedure bt9Test2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure bt18Test1Click(Sender: TObject);
    procedure cb1AutoCalcChange(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

 {$R *.lfm}

{ TForm1 }


procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
    begin
      caption := OpenDialog1.FileName;
      wbSource1.Workbook.Options := wbSource1.Workbook.Options + [boReadFormulas, boAutoCalc];
      wbSource1.Workbook.RemoveAllWorksheets;
      wbSource1.Workbook.ReadFromFile(OpenDialog1.FileName);
      wbSource1.Workbook.Options := wbSource1.Workbook.Options + [ boAutoCalc ];
      cb1AutoCalc.Checked := True;
      wsGrid1.WorkbookSource := wbSource1;
      bt1Src.Caption:= 'Dettached workbook from Grid';
   //  wbSource1.Workbook.Options := wbSource1.Workbook.Options;
    end;
end;

procedure TForm1.bt1SrcClick(Sender: TObject);
begin
  with wsGrid1 do
    begin
      if WorkbookSource = wbSource1 then
        begin
          bt1Src.Caption:= 'Attach workbook to Grid';
          WorkbookSource := nil
        end
      else
        begin
          bt1Src.Caption:= 'Dettach workbook from Grid';
          WorkbookSource := wbSource1;
        end;
    end;
//  Application.ProcessMessages;
end;


procedure TForm1.Button2Click(Sender: TObject);
var tt: Integer;
begin
  tt := GetTickCount;
  wbSource1.Workbook.CalcFormulas;
//  wbSource1.Worksheet.CalcSheet//;
  ShowMessage( IntToStr(GetTickCount - tt) + ' ms') ;
end;

procedure TForm1.bt9Test2Click(Sender: TObject);
var  sh: TsWorksheet;
  r: Cardinal; rx: string;
//  tt: integer;
begin
  sh := wbSource1.Workbook.ActiveWorksheet;
  sh.Clear;
  wbSource1.Options := wbSource1.Options - [boAutoCalc];
  for r :=0 to 4999 do
    begin
      rx := IntToStr(r+1);
      sh.WriteNumber(r, 1, r);
      sh.WriteFormula(r, 0, '=SUM(B'+ rx + ':Z' + rx + ')');
    end;
  cb1AutoCalcChange(Sender);

  {Application.ProcessMessages;
  tt := GetTickCount;
  sh.CalcFormulas;
  ShowMessage(IntToStr(GetTickCount - tt) + ' ms' );}
end;

procedure TForm1.bt18Test1Click(Sender: TObject);
var  sh: TsWorksheet;
  r: Cardinal;
 // tt: integer;
begin
  sh := wbSource1.Workbook.ActiveWorksheet;
  sh.Clear;
  wbSource1.Options := wbSource1.Options - [boAutoCalc];
  for r :=0 to 4999 do
    begin
      sh.WriteNumber(r, 1, r);
      sh.WriteFormula(r, 0, '=B'+IntToStr(r+1));
    end;
  cb1AutoCalcChange(Sender);

  //  Application.ProcessMessages;
 //   tt := GetTickCount;
 //   sh.CalcFormulas;
 //   ShowMessage(IntToStr(GetTickCount - tt) + ' ms' );
end;



procedure TForm1.cb1AutoCalcChange(Sender: TObject);
begin
  with wbSource1 do
  if cb1AutoCalc.Checked then
    OPtions := Options + [boAutoCalc]
  else
    OPtions := Options - [boAutoCalc]
end;

end.

